#pragma once
#pragma pack(push)
#pragma pack(1)

namespace Lmt {
namespace Max2Bms {
	class PtFormat {
	public:
		struct Header {
			unsigned char signature[4];  //"PTFF"
			unsigned char unknown01[8];
			unsigned short numberOfEztr;   //gbN
			unsigned char unknown02[2];
			unsigned char unknown03[6];
			unsigned short numberOfSound;  //TEhf[^̐
		};
		
		struct SoundDef {
			unsigned char identifier;  //Identifier of this entry
			unsigned char flags;
			char fileName[64];
		};
		
		struct TrackHeader {
			char signature[4];          //"EZTR"
			unsigned char padding1[2];  //0
			char trackName[64];         //gbN̖Oiėǂj
			unsigned long lastPosition; //̃gbN̍ŏIʒu
			unsigned long dataLength;   //gbNf[^̒i11Ŋ؂͂j
//			unsigned char trackData[dataLength];
		};
		
		struct TrackObject {
			unsigned long position;    //ʒui\192ŕ\Ăj
			unsigned char objectType;  //IuWFNg̎
			unsigned char detail[6];  //ef[^
		};
		
		//IuWFNg̏ڍ׃f[^
		struct DetailSound {
			unsigned char identifier;  //TEh̎ʎq
			unsigned char unknown[3];  //킩炎
			unsigned short length;     //̒@6ȉ(32)ŒPm[g@ŃOm[g
		};

		struct DetailTempo {
			float tempo;               //VBPM
			unsigned char notUsed[2];  //gpH
		};
	};
}
}

#pragma pack(pop)