#pragma once

namespace Lmt {
namespace Max2Bms {
	enum BmsChannels {
		BackgroundBmsCh = 1,
		MeasureLengthBmsCh = 2,
		ChangeTempoBmsCh = 3,
		AnimationBmsCh = 4,
		MissLayerBmsCh = 6,
		AnimationLayerBmsCh = 7,
		ExtendedChangeTempoBmsCh = 8,
		StopSequenceBmsCh = 9,
		//Playable keys
		P1Line1BmsCh = 11,
		P1Line2BmsCh = 12,
		P1Line3BmsCh = 13,
		P1Line4BmsCh = 14,
		P1Line5BmsCh = 15,
		P1ScratchBmsCh = 16,
		P1PedalBmsCh = 17,
		P1Line6BmsCh = 18,
		P1Line7BmsCh = 19,
		P2Line1BmsCh = 21,
		P2Line2BmsCh = 22,
		P2Line3BmsCh = 23,
		P2Line4BmsCh = 24,
		P2Line5BmsCh = 25,
		P2ScratchBmsCh = 26,
		P2PedalBmsCh = 27,
		P2Line6BmsCh = 28,
		P2Line7BmsCh = 29,
		//Long notes
		P1Ln1BmsCh = 51,
		P1Ln2BmsCh = 52,
		P1Ln3BmsCh = 53,
		P1Ln4BmsCh = 54,
		P1Ln5BmsCh = 55,
		P1LnScratchBmsCh = 56,
		P1LnPedalBmsCh = 57,
		P1Ln6BmsCh = 58,
		P1Ln7BmsCh = 59,
		P2Ln1BmsCh = 61,
		P2Ln2BmsCh = 62,
		P2Ln3BmsCh = 63,
		P2Ln4BmsCh = 64,
		P2Ln5BmsCh = 65,
		P2LnScratchBmsCh = 66,
		P2LnPedalBmsCh = 67,
		P2Ln6BmsCh = 68,
		P2Ln7BmsCh = 69,
	};
}
}