#pragma once

namespace Lmt {
	class CsvReader {
	public:
		CsvReader( void );
		~CsvReader( void );
		wstring GetValue( void ) const;
		const wstring & GetValueRef( void ) const;
		bool IsOpen( void ) const;
		bool Open( const wstring &path, const wchar_t sep = L',' );
		void Close( void );
		bool NextColumn( void );
		bool Fetch( void );
	private:
		void Initialize( void );
	private:
		wfstream *m_pfs;
		wchar_t m_sep;
		size_t m_index;
		size_t m_next;
		wstring m_line;
		wstring m_value;
		bool m_endl;
	};
}
