#pragma once

#include "PtFormat.hpp"
#include "TrackElement.hpp"

namespace Lmt {
namespace Max2Bms {
	class Track {
		const unsigned char *m_ptrackRaw;
		const PtFormat::TrackHeader *m_pheader;
		const unsigned char *m_pelements;
	public:
		Track( void );
		~Track( void );
		int GetElementCount( void ) const;
		wstring GetTrackName( void ) const;
		bool GetElement( int index, TrackElement &element ) const;
		bool Initialize( const unsigned char *pelementRaw );
	};
}
}
