#pragma once

#include "PtFormat.hpp"
#include "PtTrackElementTypes.hpp"

namespace Lmt {
namespace Max2Bms {
	class TrackElement {
	protected:
		const PtFormat::TrackObject *m_pelement;
	public:
		TrackElement( void );
		virtual ~TrackElement( void );
		int GetPosition( void ) const;
		PtTrackElementTypes GetType( void ) const;
		const void * GetDetail() const;
		bool Initialize( const unsigned char *pelement );
	};
}
}
